﻿using System;
using System.Diagnostics;
using System.Drawing.Printing;
using System.IO;
using System.Windows.Forms;

namespace Test
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            PrintDocument print = new PrintDocument();
            string sDefault = print.PrinterSettings.PrinterName;//默认打印机名

            foreach (string sPrint in PrinterSettings.InstalledPrinters)//获取所有打印机名称
            {
                cbxPrinter.Items.Add(sPrint);
                if (sPrint == sDefault)
                    cbxPrinter.SelectedIndex = cbxPrinter.Items.IndexOf(sPrint);
            }
        }
        private void btnSelectFile_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "PDF文件|*.pdf";
            if (ofd.ShowDialog() != DialogResult.OK) return;
            tbxFileSource.Text = ofd.FileName;
        }

        private void btnSelectSaveFolder_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog ofd = new FolderBrowserDialog();
            if (ofd.ShowDialog() != DialogResult.OK) return;
            tbxSaveFolder.Text = ofd.SelectedPath;
        }

        private void btnExportImage_Click(object sender, EventArgs e)
        {
            btnExportImage.Enabled = false;
            cbxToPng.Text = "导出PNG";
            cbxToJpeg.Text = "导出JPEG";
            if (cbxToPng.Checked)
            {
                Stopwatch sw = new Stopwatch();
                sw.Start();
                var status = Kivii.GhostScript.Instance.ToPng(tbxFileSource.Text, Path.Combine(tbxSaveFolder.Text, "%d.png"),tbxPages.Text,(int)nudResolution.Value);
                sw.Stop();
                cbxToPng.Text = $"导出PNG,结果:{status},耗时{sw.Elapsed.TotalMilliseconds}毫秒";
            }
            if (cbxToJpeg.Checked)
            {
                Stopwatch sw = new Stopwatch();
                sw.Start();
                var status = Kivii.GhostScript.Instance.ToJpeg(tbxFileSource.Text, Path.Combine(tbxSaveFolder.Text, "%d.jpg"), tbxPages.Text, (int)nudResolution.Value);
                sw.Stop();
                cbxToJpeg.Text = $"导出JPEG,结果:{status},耗时{sw.Elapsed.TotalMilliseconds}毫秒";
            }
            btnExportImage.Enabled = true;
        }

        private void btnPrint_Click(object sender, EventArgs e)
        {
            Kivii.GhostScript.Instance.ToPrinter(tbxFileSource.Text, cbxPrinter.SelectedItem.ToString(), (int)nudPrintCopies.Value, tbxPages.Text, (int)nudResolution.Value);
        }

        private void btnRun_Click(object sender, EventArgs e)
        {
            btnRun.Enabled = false;
            btnRun.Text = "执行(RUN)";
            btnRun.Text="执行(RUN="+Kivii.GhostScript.Instance.Run(rtbArguments.Lines)+")";
            btnRun.Enabled = true;
        }
    }
}
